#include <gtk/gtk.h>

//for xml
#include <libxml/xmlreader.h>
#include <libxml/encoding.h>
#include <libxml/xmlwriter.h>

gchar *
WriteXHTML_as_Markup (GtkTextBuffer *textbuffer,
				      const char *file);

gchar *
WriteXHTML	(GtkTextBuffer *textbuffer,
			 const char *file);

GtkTextBuffer *create_buffer (GtkTextView *textview, gboolean writeable);

void
		set_XHTML (GtkTextBuffer *textbuffer,
			      gchar *text);

void
		add_undo (GtkTextBuffer *textbuffer);

void
		add_redo (GtkTextBuffer *textbuffer);

void
		Undo                 (GtkTextBuffer *textbuffer);

void
		Redo                 (GtkTextBuffer *textbuffer);

void
		toggle_Bold                 (GtkTextBuffer *textbuffer);

void
		toggle_Italic               (GtkTextBuffer *textbuffer);

void
		toggle_Underline                (GtkTextBuffer *textbuffer);

void
		toggle_Strikethrough             (GtkTextBuffer *textbuffer);

void
		toggle_Superscript                (GtkTextBuffer *textbuffer);

void
		toggle_Subscript                  (GtkTextBuffer *textbuffer);

void
		open_color_dialog                (GtkTextBuffer *textbuffer);

void
		open_symbol_dialog            (GtkTextBuffer *textbuffer);

void
		processHTMLNode				(GtkTextBuffer *textbuffer,
							xmlTextReaderPtr reader);

void
		import_XHTML  				(GtkTextBuffer *textbuffer, gchar * xml);

int 
		strrepl(char *InputString,char *StringToFind,
			char *StringToReplace,char *output);

void
		on_button_Symbol_activate                    (GtkButton       *button,
		gpointer         user_data);

void
		on_button_Symbol_clicked                    (GtkButton       *button,
		gpointer         user_data);

void
		on_buffer_changed      (GtkTextBuffer *textbuffer,
					gpointer       user_data);
